Python 3.13.7 (tags/v3.13.7:bcee1c3, Aug 14 2025, 14:15:11) [MSC v.1944 64 bit (AMD64)] on win32
Enter "help" below or click "Help" above for more information.
def uspeh():
    """Подтверждение успеха операции"""
    print('Выполнено успешно!')

    
uspeh()
Выполнено успешно!
type(uspeh)
<class 'function'>
dir()
['__annotations__', '__builtins__', '__doc__', '__loader__', '__name__', '__package__', '__spec__', 'uspeh']
help(uspeh)
Help on function uspeh in module __main__:

uspeh()
    Подтверждение успеха операции

def sravnenie(a,b):
    """Сравнение a и b"""
    if a>b:
        print(a,' больше ',b)
    elif a<b:
        print(a, ' меньше ',b)
    else:
        print(a, ' равно ',b)

        
n,m=16,5;sravnenie(n,m)
16  больше  5
n,m="16","5";sravnenie(n,m)
16  меньше  5
def logistfun(b,a):
    """Вычисление логистической функции"""
    import math
    return a/(1+math.exp(-b))

v,w=1,0.7;z=logistfun(w,v)
z
0.6681877721681662
def slozh(a1,a2,a3,a4):
    """ Сложение значений четырех аргументов"""
    return a1+a2+a3+a4

slozh(1,2,3,4)
10
slozh('1','2','3','4')
'1234'
b1=[1,2];b2=[-1,-2];b3=[0,2];b4=[-1,-1]
q=slozh(b1,b2,b3,b4)
kor1 = ("s", 1, "n")
kor2 = ("e", 2, "g")
kor3 = ("u", 3, "r")
slozh(kor1, kor2, kor3)
Traceback (most recent call last):
  File "<pyshell#23>", line 1, in <module>
    slozh(kor1, kor2, kor3)
TypeError: slozh() missing 1 required positional argument: 'a4'
s=slozh(kor1, kor2, kor3)
Traceback (most recent call last):
  File "<pyshell#24>", line 1, in <module>
    s=slozh(kor1, kor2, kor3)
TypeError: slozh() missing 1 required positional argument: 'a4'
kor4= ("a" , 4, "d")
k=slozh(kor1, kor2, kor3, kor4)
k
('s', 1, 'n', 'e', 2, 'g', 'u', 3, 'r', 'a', 4, 'd')
sl1 = {"A": 1, "B": 2}
sl2 = {"B": 3, "C": 4}
sl2 = {"D": 5, "E": 6}
sl2 = {"B": 3, "C": 4}
sl3 = {"D": 5, "E": 6}
sl4 = {"F": 7, "H": 8}
sl=slozh(sl1, sl2, sl3, sl4)
Traceback (most recent call last):
  File "<pyshell#34>", line 1, in <module>
    sl=slozh(sl1, sl2, sl3, sl4)
  File "<pyshell#15>", line 3, in slozh
    return a1+a2+a3+a4
TypeError: unsupported operand type(s) for +: 'dict' and 'dict'
mn1 = {"A", "B"}
mn2 = {"C", "D"}
mn3 = {"E", "F"}
mn4 = {"H", "J"}
mn=slozh(mn1, mn2, mn3, mn4)
Traceback (most recent call last):
  File "<pyshell#39>", line 1, in <module>
    mn=slozh(mn1, mn2, mn3, mn4)
  File "<pyshell#15>", line 3, in slozh
    return a1+a2+a3+a4
TypeError: unsupported operand type(s) for +: 'set' and 'set'
def inerz(x,T,ypred):
    """ Модель устройства с памятью:
    x- текущее значение вх.сигнала,
    T -постоянная времени,
    ypred - предыдущее значение выхода устройства"""
    y=(x+T*ypred)/(T+1)
    return y

sps=[0]+[1]*100
spsy=[] #Заготовили список для значений выхода
TT=20 #Постоянная времени

>>>sps=[0]+[1]*100
>>>spsy=[] #Заготовили список для значений выхода
>>>TT=20 #Постоянная времени
>>>yy=0  #Нулевое начальное условие
SyntaxError: invalid syntax
yy=0  #Нулевое начальное условие
for xx in sps:
    yy=inerz(xx,TT,yy)
    spsy.append(yy)

    
import pylab
spsm = list(range(101))
pylab.plot(spsm, spsy)
[<matplotlib.lines.Line2D object at 0x00000224201125D0>]
pylab.show()
dir(inerz)
['__annotations__', '__builtins__', '__call__', '__class__', '__closure__', '__code__', '__defaults__', '__delattr__', '__dict__', '__dir__', '__doc__', '__eq__', '__format__', '__ge__', '__get__', '__getattribute__', '__getstate__', '__globals__', '__gt__', '__hash__', '__init__', '__init_subclass__', '__kwdefaults__', '__le__', '__lt__', '__module__', '__name__', '__ne__', '__new__', '__qualname__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__type_params__']
inerz.__doc__
'Модель устройства с памятью:\nx- текущее значение вх.сигнала,\nT -постоянная времени,\nypred - предыдущее значение выхода устройства'
help(inerz)
Help on function inerz in module __main__:

inerz(x, T, ypred)
    Модель устройства с памятью:
    x- текущее значение вх.сигнала,
    T -постоянная времени,
    ypred - предыдущее значение выхода устройства

fnkt=sravnenie
v=16
fnkt(v,23)
16  меньше  23
typ_fun=8
if typ_fun==1:
    def func():
        print('Функция 1')
else:
    def func():
        print('Функция 2')

        
func()
Функция 2
def fun_arg(fff,a,b,c):
    """fff-имя функции, используемой 
    в качестве аргумента функции fun_arg"""
    return a+fff(c,b)

zz=fun_arg(logistfun,-3,1,0.7)
zz
-2.3318122278318336
def logistfun(a,b=1):   #Аргумент b – необязательный; значение по умолчанию=1
    """Вычисление логистической функции"""
    import math
    return b/(1+math.exp(-a))

logistfun(0.7)     #Вычисление со значением b по умолчанию
0.6681877721681662
logistfun(0.7,2)  #Вычисление с заданным значением b
1.3363755443363323
logistfun(b=0.5,a=0.8)  # Ссылки на аргументы поменялись местами
0.34498724056380625
b1234=[b1,b2,b3,b4]  # Список списков из п.2.4
qq=slozh(*b1234)  #Перед ссылкой на список или кортеж надо ставить звездочку
qq
[1, 2, -1, -2, 0, 2, -1, -1]
dic4={"a1":1,"a2":2,"a3":3,"a4":4}
qqq=slozh(**dic4)  #Перед ссылкой на словарь надо ставить две звездочки
qqq
10
e1=(-1,6);dd2={'a3':3,'a4':9}
qqqq=slozh(*e1,**dd2)
qqqq
17
def func4(*kort7):
    """Произвольное число аргументов в составе кортежа"""
    smm=0
    for elt in kort7:
        smm+=elt
    return smm

func4(-1,2)  #Обращение к функции с 2 аргументами
1
func4(-1,2,0,3,6)  #Обращение к функции с 5 аргументами
10
def func4(a,b=7,*kort7): #Аргументы: a-позиционный, b- по умолчанию + кортеж
    """Кортеж - сборка аргументов - должен быть последним!"""
    smm=0
    for elt in kort7:
	smm+=elt
    return a*smm+b
SyntaxError: inconsistent use of tabs and spaces in indentation
def func4(a,b=7,*kort7): #Аргументы: a-позиционный, b- по умолчанию + кортеж
    """Кортеж - сборка аргументов - должен быть последним!"""
    smm=0
    for elt in kort7:
        smm+=elt
    return a*smm+b

func4(-1,2,0,3,6)
-7
def func5(**slovar):
    print(slovar)

    
func5(a=1, n=2, m=3)
{'a': 1, 'n': 2, 'm': 3}
a=90    # Числовой объект – не изменяемый тип
def func3(b):
    a=5*b+67

    
a
90
sps1=[1,2,3,4]  #Список – изменяемый тип объекта
def func2(sps):
    sps[1]=99

    
func2(sps1)
print(sps1)
[1, 99, 3, 4]
kort=(1,2,3,4)   #Кортеж – неизменяемый тип объекта
func2(kort)
Traceback (most recent call last):
  File "<pyshell#102>", line 1, in <module>
    func2(kort)
  File "<pyshell#98>", line 2, in func2
    sps[1]=99
TypeError: 'tuple' object does not support item assignment
import math
anfun1=lambda: 1.5+math.log10(17.23)  #Анонимная функция без аргументов
anfun1()   # Обращение к объекту-функции
2.7362852774480286
anfun2=lambda a,b : a+math.log10(b)  #Анонимная функция с 2 аргументами
anfun2(17,234)
19.369215857410143
anfun3=lambda a,b=234: a+math.log10(b) #Функция с необязательным вторым аргументом
anfun3(100)
102.36921585741014
def func5(diap,shag):
    """ Итератор, возвращающий значения
    из диапазона от 1 до diap с шагом shag"""
    for j in range(1,diap+1,shag):
        yield j

        
for mm in func5(7,3):
    print(mm)

    
1
4
7
alp=func5(7,3)
print(alp.__next__())
1
print(alp.__next__())
4
print(alp.__next__())
7
print(alp.__next__())
Traceback (most recent call last):
  File "<pyshell#118>", line 1, in <module>
    print(alp.__next__())
StopIteration
glb=10
def func7(arg):
    loc1=15
    glb=8
    return loc1*arg

res=func7(glb)
res
150
glb
10
def func8(arg):
    loc1=15
    print(glb)  
    glb=8
    return loc1*arg

res=func8(glb)
Traceback (most recent call last):
  File "<pyshell#128>", line 1, in <module>
    res=func8(glb)
  File "<pyshell#127>", line 3, in func8
    print(glb)
UnboundLocalError: cannot access local variable 'glb' where it is not associated with a value
glb=11
def func7(arg):
    loc1=15
    global glb
    print(glb)
    glb=8
    return loc1*arg

res=func7(glb)
11
glb
8
res
165
globals().keys()  #Перечень глобальных объектов
dict_keys(['__name__', '__doc__', '__package__', '__loader__', '__spec__', '__annotations__', '__builtins__', 'uspeh', 'sravnenie', 'n', 'm', 'logistfun', 'v', 'w', 'z', 'slozh', 'b1', 'b2', 'b3', 'b4', 'q', 'kor1', 'kor2', 'kor3', 'kor4', 'k', 'sl1', 'sl2', 'sl3', 'sl4', 'mn1', 'mn2', 'mn3', 'mn4', 'inerz', 'sps', 'spsy', 'TT', 'yy', 'xx', 'pylab', 'spsm', 'fnkt', 'typ_fun', 'func', 'fun_arg', 'zz', 'b1234', 'qq', 'dic4', 'qqq', 'e1', 'dd2', 'qqqq', 'func4', 'func5', 'a', 'func3', 'sps1', 'func2', 'kort', 'math', 'anfun1', 'anfun2', 'anfun3', 'mm', 'alp', 'glb', 'func7', 'res', 'func8'])
locals().keys()  #Перечень локальных объектов
dict_keys(['__name__', '__doc__', '__package__', '__loader__', '__spec__', '__annotations__', '__builtins__', 'uspeh', 'sravnenie', 'n', 'm', 'logistfun', 'v', 'w', 'z', 'slozh', 'b1', 'b2', 'b3', 'b4', 'q', 'kor1', 'kor2', 'kor3', 'kor4', 'k', 'sl1', 'sl2', 'sl3', 'sl4', 'mn1', 'mn2', 'mn3', 'mn4', 'inerz', 'sps', 'spsy', 'TT', 'yy', 'xx', 'pylab', 'spsm', 'fnkt', 'typ_fun', 'func', 'fun_arg', 'zz', 'b1234', 'qq', 'dic4', 'qqq', 'e1', 'dd2', 'qqqq', 'func4', 'func5', 'a', 'func3', 'sps1', 'func2', 'kort', 'math', 'anfun1', 'anfun2', 'anfun3', 'mm', 'alp', 'glb', 'func7', 'res', 'func8'])
def func8(arg):
    loc1=15
    glb=8
    print(globals().keys())  #Перечень глобальных объектов «изнутри» функции
    print(locals().keys())  #Перечень локальных объектов «изнутри» функции
    return loc1*arg

hh=func8(glb) #В этом случае глобальные обьекты остались те же, а вот место локализации теперь - это функция, и в ней существуют три локальных обьекта.
dict_keys(['__name__', '__doc__', '__package__', '__loader__', '__spec__', '__annotations__', '__builtins__', 'uspeh', 'sravnenie', 'n', 'm', 'logistfun', 'v', 'w', 'z', 'slozh', 'b1', 'b2', 'b3', 'b4', 'q', 'kor1', 'kor2', 'kor3', 'kor4', 'k', 'sl1', 'sl2', 'sl3', 'sl4', 'mn1', 'mn2', 'mn3', 'mn4', 'inerz', 'sps', 'spsy', 'TT', 'yy', 'xx', 'pylab', 'spsm', 'fnkt', 'typ_fun', 'func', 'fun_arg', 'zz', 'b1234', 'qq', 'dic4', 'qqq', 'e1', 'dd2', 'qqqq', 'func4', 'func5', 'a', 'func3', 'sps1', 'func2', 'kort', 'math', 'anfun1', 'anfun2', 'anfun3', 'mm', 'alp', 'glb', 'func7', 'res', 'func8'])
dict_keys(['arg', 'loc1', 'glb'])
'glb' in globals().keys()
True
def func9(arg2,arg3):
    def func9_1(arg1):
        loc1=15
        glb1=8
        print('glob_func9_1:',globals().keys())
        print('locl_func9_1:',locals().keys())
        return loc1*arg1
    loc1=5
    glb=func9_1(loc1)
    print('loc_func9:',locals().keys())
    print('glob_func9:',globals().keys())
    return arg2+arg3*glb

kk=func9(10,1)
glob_func9_1: dict_keys(['__name__', '__doc__', '__package__', '__loader__', '__spec__', '__annotations__', '__builtins__', 'uspeh', 'sravnenie', 'n', 'm', 'logistfun', 'v', 'w', 'z', 'slozh', 'b1', 'b2', 'b3', 'b4', 'q', 'kor1', 'kor2', 'kor3', 'kor4', 'k', 'sl1', 'sl2', 'sl3', 'sl4', 'mn1', 'mn2', 'mn3', 'mn4', 'inerz', 'sps', 'spsy', 'TT', 'yy', 'xx', 'pylab', 'spsm', 'fnkt', 'typ_fun', 'func', 'fun_arg', 'zz', 'b1234', 'qq', 'dic4', 'qqq', 'e1', 'dd2', 'qqqq', 'func4', 'func5', 'a', 'func3', 'sps1', 'func2', 'kort', 'math', 'anfun1', 'anfun2', 'anfun3', 'mm', 'alp', 'glb', 'func7', 'res', 'func8', 'hh', 'func9'])
locl_func9_1: dict_keys(['arg1', 'loc1', 'glb1'])
loc_func9: dict_keys(['arg2', 'arg3', 'func9_1', 'loc1', 'glb'])
glob_func9: dict_keys(['__name__', '__doc__', '__package__', '__loader__', '__spec__', '__annotations__', '__builtins__', 'uspeh', 'sravnenie', 'n', 'm', 'logistfun', 'v', 'w', 'z', 'slozh', 'b1', 'b2', 'b3', 'b4', 'q', 'kor1', 'kor2', 'kor3', 'kor4', 'k', 'sl1', 'sl2', 'sl3', 'sl4', 'mn1', 'mn2', 'mn3', 'mn4', 'inerz', 'sps', 'spsy', 'TT', 'yy', 'xx', 'pylab', 'spsm', 'fnkt', 'typ_fun', 'func', 'fun_arg', 'zz', 'b1234', 'qq', 'dic4', 'qqq', 'e1', 'dd2', 'qqqq', 'func4', 'func5', 'a', 'func3', 'sps1', 'func2', 'kort', 'math', 'anfun1', 'anfun2', 'anfun3', 'mm', 'alp', 'glb', 'func7', 'res', 'func8', 'hh', 'func9'])
znach=input('k1,T,k2,Xm,A,F,N=').split(',')
k1,T,k2,Xm,A,F,N=0.5,35,0.6,5,1000,5,15
k1=float(znach[0])
T=float(znach[1])
k2=float(znach[2])
Xm=float(znach[3])
A=float(znach[4])
F=float(znach[5])
N=int(znach[6])
import math
vhod=[]
for i in range(N):
    vhod.append(A*math.sin((2*i*math.pi)/F))

    
vhod
[0.0, 951.0565162951535, 587.7852522924733, -587.785252292473, -951.0565162951536, -2.4492935982947065e-13, 951.0565162951535, 587.7852522924734, -587.7852522924728, -951.0565162951538, -4.898587196589413e-13, 951.0565162951528, 587.7852522924736, -587.7852522924726, -951.0565162951538]
def realdvig(xtt,kk1,TT,yti1,ytin1):
    #Модель реального двигателя
    yp=kk1*xtt  #усилитель
    yti1=yp+yti1  #Интегратор
    ytin1=(yti1+TT*ytin1)/(TT+1)
    return [yti1,ytin1]

def tahogen(xtt,kk2,yti2):
    #Модель тахогенератора
    yp=kk2*xtt   #усилитель
    yti2=yp+yti2 #интегратор
    return yti2

def nechus(xtt,gran):
    #зона нечувствительности
    if xtt<gran and xtt>(-gran):
        ytt=0
    elif xtt>=gran:
        ytt=xtt-gran
    elif xtt<=(-gran):
        ytt=xtt+gran
    return ytt
... 
>>> yi1=0;yin1=0;yi2=0
>>> vyhod=[]
>>> for xt in vhod:
...     xt1=xt-yi2   #отрицательная обратная связь
...     [yi1,yin1]=realdvig(xt1,k1,T,yi1,yin1)
...     yi2=tahogen(yin1,k2,yi2)
...     yt=nechus(yin1,Xm)
...     vyhod.append(yt)
... 
...     
>>> print('y=',vyhod)
y= [0, 8.209118281877132, 29.104924685415277, 40.86232427117668, 38.3075414151359, 34.68635884409398, 42.90679739719954, 57.19526562043458, 60.53754513466764, 47.64611630565597, 31.742316122264157, 25.812753880749888, 24.278160244795345, 10.44509996519298, -10.518946273258612]
